/**
 * \file definition.h
 *
 * \brief File containing some macro definitions, which permits
 *        to configure the \em stegocurve before the compilation.
 *
 * \author Morgan Barbier <morgan.barbier@ensicaen.fr>
 *
 * \version 1.0
 *
 * \date 2014-10-15
 *
 * \copyright This file is part of stegocurve.

 stegocurve is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 stegocurve is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with stegocurve. If not, see <http://www.gnu.org/licenses/>.

 */
#ifndef __DEFINITION_H__
#define __DEFINITION_H__

/**
 * \def uint 
 *
 * MACRO which means unsigned int.
 */
#define uint unsigned int

/**
 * \def GNUPLOT_FILE 
 * \brief Macro containing the gnuplot filename.
 */
#define GNUPLOT_FILE    "stegocurve.gnu"

/**
 * \def GNUPLOT_COMMAND 
 * \brief Macro containing the gnuplot executable.
 */
#define GNUPLOT_COMMAND "gnuplot" 
/**
 * \def CONVERS_COMMAND 
 * \brief Macro containing the name of executable to
 *        convert eps file to pdf file.
 */
#define CONVERS_COMMAND "epspdf"
/**
 * \def EPS_VIEWER
 * \brief Macro containing the name of eps viewer.
 */
#define EPS_VIEWER      "evince"
/**
 * \def PDF_VIEWER
 * \brief Macro containing the name of pdf viewer.
 */
#define PDF_VIEWER      "evince"
/**
 * \def LATEX_COMPILER
 * \brief Macro containing the name of Latex compiler.
 */
#define LATEX_COMPILER      "pdflatex"

#endif /* __DEFINITION_H__ */
