/**
 * \file third_applications.h
 *
 * \brief Header file for run third application. As for example
 *        latex compiler, pdf viewer, etc...
 *
 * \author Morgan Barbier <morgan.barbier@ensicaen.fr>
 *
 * \version 1.1
 *
 * \date 2015-03-04
 *
 * \copyright This file is part of stegocurve.

 stegocurve is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 stegocurve is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with stegocurve. If not, see <http://www.gnu.org/licenses/>.

 */
#ifndef __THIRD_APPLICATIONS_H__
#define __THIRD_APPLICATIONS_H__

#include <stdio.h>
#include <stdlib.h>

#ifdef __linux__
#include <stdarg.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include "tools/definition.h"

/**
 * \fn void run_and_wait(const uint argc, ...);
 *
 * \brief function wich permit to run a third application
 *        with arguments and wait that this application
 *        exit.
 *
 * \param[in] argc the number of arguments, without itself.
 * \param[in] the first one is the third application, afterwards,
 *            the arguments of this application.
 */
void run_and_wait(const uint argc, ...);
#endif /* __linux__ */

#endif /* __THIRD_APPLICATIONS_H__ */
