/**
 *This file is part of stegocurve.

 stegocurve is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 stegocurve is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with stegocurve. If not, see <http://www.gnu.org/licenses/>.
 */

#include "codes/reed-muller.h"



void init_RM_code(Code *C, const uint parameter)
{
  switch(parameter)
    {
    case 3:
      init_code_WC(C, 7, 4, 1);
      break;

    case 4:
      init_code_WC(C, 15, 5, 5);
      break;
      
    case 5:
      init_code_WC(C, 31, 6, 11);
      break;

    case 6:
      init_code_WC(C, 63, 7, 27);
      break;
      
    case 7:
      init_code_WC(C, 127, 8, 55);
      break;

    default:
      fprintf(stderr, "ERROR : init_RM_code(parameter=%d)\nParameters not known!\n", parameter);
      init_code_WC(C, 0, 0, 1);
      break;
    }
}

void init_RM_codes(Code *C, const uint start, const uint nb)
{
  init_generic_codes(C, start, nb, init_RM_code);
}

void RM_codes_WC(const char* filename)
{
  generic_codes_generic_cases(filename, 3, 5,
			      init_RM_codes,
			      display_data_WC);
}
