#include "plotters/plotter.h"


void plotter_init(Plotter *P,
		  void (*pre)(Plotter *P),
		  void (*pro)(Plotter *P),
		  void (*post)(Plotter *P),
		  const char* Plotter_filename,
		  const char* output_filename,
		  const stegocurve_args *data)
{
  size_t size;

  P->pre_processing  = pre;
  P->processing      = pro;
  P->post_processing = post;

  P->data            = data;

  P->Plotter_file    = fopen(Plotter_filename, "w");

  size = strlen(Plotter_filename);
  P->Plotter_filename = malloc(sizeof(char) * (size + 1));
  strncpy(P->Plotter_filename, Plotter_filename, strlen(Plotter_filename));
  P->Plotter_filename[size] = '\0';

  if (output_filename != NULL)
    {
      size                  = strlen(output_filename);
      P->output_filename    = malloc(sizeof(char) * (size + 1));
      strncpy(P->output_filename, output_filename, strlen(output_filename));
      P->output_filename[size] = '\0';
    }
  else
    {
      P->output_filename = NULL;
    }
}


void plotter_run(Plotter *P)
{
  P->pre_processing(P);
  P->processing(P);
  P->post_processing(P);
}

void plotter_free(Plotter *P)
{
  if (P->Plotter_file != NULL)
    {
      fclose(P->Plotter_file);
    }
  free(P->Plotter_filename);
  free(P->output_filename);
}

