#include "tools/stegocurve_args.h"

void stegocurve_args_init(stegocurve_args *A, const uint argc, const char **args)
{
  uint i = 0;

  A->size = argc/2;
  if((A->data = malloc(A->size * sizeof(char*[2]))) == NULL)
    {
      fprintf(stderr, "ERROR: stegocurve_args_init(). Memory unvailable!\n");
    }

  for(; i<argc; ++i)
    {
      stegocurve_args_set_datafile(A, i/2, args[i]);
      ++i;
      stegocurve_args_set_title   (A, i/2, args[i]);
    }
}


void stegocurve_args_init_size(stegocurve_args *A, const uint size)
{
  A->size = size;

  if((A->data = malloc(size * sizeof(char*[2]))) == NULL)
    {
      fprintf(stderr, "ERROR. stegocurve_args_init_size(). Memory unvailable.\n");
    }
}


void stegocurve_args_free(stegocurve_args *A)
{
  uint i = 0;

  for(; i<A->size; ++i)
    {
      free(A->data[i][0]);
      free(A->data[i][1]);
    }
  free(A->data);
}


uint stegocurve_args_get_size(const stegocurve_args *A)
{
  return(A->size);
}


char *stegocurve_args_get_datafile(const stegocurve_args *A, const uint i)
{
  if (i >= A->size)
    {
      return(NULL);
    }
  
  return(A->data[i][0]);
}

char *stegocurve_args_get_title(const stegocurve_args *A, const uint i)
{
  if (i >= A->size)
    {
      return(NULL);
    }
  
  return(A->data[i][1]);
}


void stegocurve_args_set_data(stegocurve_args *A, const uint i, const uint j, const char *str)
{
  uint size_str;

  if (i >= A->size)
    {
      if (j == 0)
	{
	  fprintf(stderr, "ERROR: stegocurve_args_set_datafile(). Out of bound.\n");
	}
      else
	{
	  fprintf(stderr, "ERROR: stegocurve_args_set_title(). Out of bound.\n");
	}	
    }
  
  size_str = strlen(str) + 1;
  if((A->data[i][j] = malloc(size_str * sizeof(char))) == NULL)
    {
      if (j == 0)
	{
	  fprintf(stderr, "ERROR: stegocurve_args_set_datafile(). Memory unvailable.\n");
	}
      else
	{
	  fprintf(stderr, "ERROR: stegocurve_args_set_title(). Memory unvailable.\n");
	}	
    }
  strncpy(A->data[i][j], str, size_str);
}


void stegocurve_args_set_datafile(stegocurve_args *A, const uint i, const char *str)
{
  stegocurve_args_set_data(A, i, 0, str);
}

void stegocurve_args_set_title(stegocurve_args *A, const uint i, const char *str)
{
  stegocurve_args_set_data(A, i, 1, str);
}




