#include "tools/third_applications.h"

#ifdef __linux__
void run_and_wait(const uint argc, ...)
{
  va_list arg;
  char 
    *tmp,
    **cmd_line;
  int status = 0;
  uint i;
  pid_t PID;
  size_t size_arg;

  cmd_line = malloc((argc+1) * sizeof(char*));
  va_start(arg, argc);

  for(i=0; i<argc; ++i)
    {
      tmp         = va_arg(arg, char*);
      size_arg    = strlen(tmp) + 1;
      cmd_line[i] = malloc(size_arg * sizeof(char));
      memcpy(cmd_line[i], tmp, size_arg);
    }
  cmd_line[argc] = NULL;
  va_end(arg);

  PID = fork();
  if (PID == -1)
    {
      perror("error fork()\n");
    }
  else if(PID == 0)
    {
      execvp(cmd_line[0], cmd_line);
    }
  else
    {
      wait(&status);
    }

  for(i=0; i<argc; ++i)
    {
      free(cmd_line[i]);
    }
  free(cmd_line);
}
#endif /* __linux__ */
